import { useReducer as useReducer$2, useEffect as useEffect$1, useMemo as useMemo$1, createContext, useContext, createElement, useState as useState$1 } from 'react';
import gql from 'graphql-tag';
import Cookies from 'js-cookie';
import { memoizeJ } from '@thi.ng/memoize';
import { unwindEdges } from '@good-idea/unwind-edges';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}
function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var moneyV2Fragment = gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  fragment MoneyV2Fragment on MoneyV2 {\n    amount\n    currencyCode\n  }\n"], ["\n  fragment MoneyV2Fragment on MoneyV2 {\n    amount\n    currencyCode\n  }\n"])));
var imageFragment = gql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  fragment ImageFragment on Image {\n    altText\n    id\n    originalSrc\n  }\n"], ["\n  fragment ImageFragment on Image {\n    altText\n    id\n    originalSrc\n  }\n"])));
var collectionFragment = gql(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  fragment CollectionFragment on Collection {\n    description\n    descriptionHtml\n    handle\n    id\n    image {\n      ...ImageFragment\n    }\n    title\n    updatedAt\n  }\n  ", "\n"], ["\n  fragment CollectionFragment on Collection {\n    description\n    descriptionHtml\n    handle\n    id\n    image {\n      ...ImageFragment\n    }\n    title\n    updatedAt\n  }\n  ", "\n"])), imageFragment);
var productWithoutVariantsFragment = gql(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  fragment ProductWithoutVariantsFragment on Product {\n    availableForSale\n    createdAt\n    description\n    descriptionHtml\n    handle\n    id\n    productType\n    publishedAt\n    tags\n    title\n    vendor\n    images(first: 100) {\n      edges {\n        node {\n          ...ImageFragment\n        }\n      }\n    }\n    options(first: 100) {\n      id\n      name\n      values\n    }\n    priceRange {\n      maxVariantPrice {\n        ...MoneyV2Fragment\n      }\n      minVariantPrice {\n        ...MoneyV2Fragment\n      }\n    }\n  }\n\n  ", "\n  ", "\n"], ["\n  fragment ProductWithoutVariantsFragment on Product {\n    availableForSale\n    createdAt\n    description\n    descriptionHtml\n    handle\n    id\n    productType\n    publishedAt\n    tags\n    title\n    vendor\n    images(first: 100) {\n      edges {\n        node {\n          ...ImageFragment\n        }\n      }\n    }\n    options(first: 100) {\n      id\n      name\n      values\n    }\n    priceRange {\n      maxVariantPrice {\n        ...MoneyV2Fragment\n      }\n      minVariantPrice {\n        ...MoneyV2Fragment\n      }\n    }\n  }\n\n  ", "\n  ", "\n"])), imageFragment, moneyV2Fragment);
var variantWithProductFragment = gql(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  fragment VariantWithProductFragment on ProductVariant {\n    id\n    sku\n    title\n    weight\n    weightUnit\n    compareAtPriceV2 {\n      ...MoneyV2Fragment\n    }\n    priceV2 {\n      ...MoneyV2Fragment\n    }\n    product {\n      ...ProductWithoutVariantsFragment\n    }\n    image {\n      ...ImageFragment\n    }\n    requiresShipping\n    selectedOptions {\n      name\n      value\n    }\n  }\n  ", "\n  ", "\n  ", "\n"], ["\n  fragment VariantWithProductFragment on ProductVariant {\n    id\n    sku\n    title\n    weight\n    weightUnit\n    compareAtPriceV2 {\n      ...MoneyV2Fragment\n    }\n    priceV2 {\n      ...MoneyV2Fragment\n    }\n    product {\n      ...ProductWithoutVariantsFragment\n    }\n    image {\n      ...ImageFragment\n    }\n    requiresShipping\n    selectedOptions {\n      name\n      value\n    }\n  }\n  ", "\n  ", "\n  ", "\n"])), moneyV2Fragment, productWithoutVariantsFragment, imageFragment);
var variantFragment = gql(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  fragment VariantFragment on ProductVariant {\n    availableForSale\n    id\n    sku\n    title\n    weight\n    weightUnit\n    compareAtPriceV2 {\n      ...MoneyV2Fragment\n    }\n    priceV2 {\n      ...MoneyV2Fragment\n    }\n    requiresShipping\n    selectedOptions {\n      name\n      value\n    }\n    image {\n      ...ImageFragment\n    }\n  }\n  ", "\n  ", "\n"], ["\n  fragment VariantFragment on ProductVariant {\n    availableForSale\n    id\n    sku\n    title\n    weight\n    weightUnit\n    compareAtPriceV2 {\n      ...MoneyV2Fragment\n    }\n    priceV2 {\n      ...MoneyV2Fragment\n    }\n    requiresShipping\n    selectedOptions {\n      name\n      value\n    }\n    image {\n      ...ImageFragment\n    }\n  }\n  ", "\n  ", "\n"])), moneyV2Fragment, imageFragment);
var productFragment = gql(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  fragment ProductFragment on Product {\n    availableForSale\n    createdAt\n    description\n    descriptionHtml\n    handle\n    id\n    productType\n    publishedAt\n    tags\n    title\n    vendor\n    images(first: 100) {\n      edges {\n        node {\n          ...ImageFragment\n        }\n      }\n    }\n    options(first: 100) {\n      id\n      name\n      values\n    }\n    priceRange {\n      maxVariantPrice {\n        ...MoneyV2Fragment\n      }\n      minVariantPrice {\n        ...MoneyV2Fragment\n      }\n    }\n    variants(first: 100) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        node {\n          ...VariantFragment\n        }\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"], ["\n  fragment ProductFragment on Product {\n    availableForSale\n    createdAt\n    description\n    descriptionHtml\n    handle\n    id\n    productType\n    publishedAt\n    tags\n    title\n    vendor\n    images(first: 100) {\n      edges {\n        node {\n          ...ImageFragment\n        }\n      }\n    }\n    options(first: 100) {\n      id\n      name\n      values\n    }\n    priceRange {\n      maxVariantPrice {\n        ...MoneyV2Fragment\n      }\n      minVariantPrice {\n        ...MoneyV2Fragment\n      }\n    }\n    variants(first: 100) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        node {\n          ...VariantFragment\n        }\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"])), imageFragment, moneyV2Fragment, variantFragment);
var discountApplicationFragment = gql(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  fragment DiscountApplicationFragment on DiscountApplication {\n    allocationMethod\n    targetSelection\n    targetType\n    ... on DiscountCodeApplication {\n      code\n      applicable\n    }\n    value {\n      ... on PricingPercentageValue {\n        percentage\n      }\n      ... on MoneyV2 {\n        ...MoneyV2Fragment\n      }\n    }\n  }\n  ", "\n"], ["\n  fragment DiscountApplicationFragment on DiscountApplication {\n    allocationMethod\n    targetSelection\n    targetType\n    ... on DiscountCodeApplication {\n      code\n      applicable\n    }\n    value {\n      ... on PricingPercentageValue {\n        percentage\n      }\n      ... on MoneyV2 {\n        ...MoneyV2Fragment\n      }\n    }\n  }\n  ", "\n"])), moneyV2Fragment);
var lineItemFragment = gql(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n  fragment LineItemFragment on CheckoutLineItem {\n    id\n    quantity\n    title\n    discountAllocations {\n      allocatedAmount {\n        ...MoneyV2Fragment\n      }\n      discountApplication {\n        ...DiscountApplicationFragment\n      }\n    }\n    variant {\n      ...VariantWithProductFragment\n    }\n  }\n  ", "\n  ", "\n"], ["\n  fragment LineItemFragment on CheckoutLineItem {\n    id\n    quantity\n    title\n    discountAllocations {\n      allocatedAmount {\n        ...MoneyV2Fragment\n      }\n      discountApplication {\n        ...DiscountApplicationFragment\n      }\n    }\n    variant {\n      ...VariantWithProductFragment\n    }\n  }\n  ", "\n  ", "\n"])), discountApplicationFragment, variantWithProductFragment);
var checkoutFragment = gql(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  fragment CheckoutFragment on Checkout {\n    id\n    paymentDueV2 {\n      ...MoneyV2Fragment\n    }\n    webUrl\n    completedAt\n    shippingLine {\n      handle\n      price\n      title\n    }\n    email\n    discountApplications(first: 100) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...DiscountApplicationFragment\n        }\n      }\n    }\n    lineItems(first: 100) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...LineItemFragment\n        }\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"], ["\n  fragment CheckoutFragment on Checkout {\n    id\n    paymentDueV2 {\n      ...MoneyV2Fragment\n    }\n    webUrl\n    completedAt\n    shippingLine {\n      handle\n      price\n      title\n    }\n    email\n    discountApplications(first: 100) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...DiscountApplicationFragment\n        }\n      }\n    }\n    lineItems(first: 100) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...LineItemFragment\n        }\n      }\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n"])), moneyV2Fragment, discountApplicationFragment, lineItemFragment);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10;

var CHECKOUT_CREATE = gql(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  mutation CheckoutCreate(\n    $email: String\n    $lineItems: [CheckoutLineItemInput!]\n    $shippingAddress: MailingAddressInput\n    $note: String\n    $customAttributes: [AttributeInput!]\n    $allowPartialAddresses: Boolean\n  ) {\n    checkoutCreate(\n      input: {\n        email: $email\n        lineItems: $lineItems\n        shippingAddress: $shippingAddress\n        note: $note\n        customAttributes: $customAttributes\n        allowPartialAddresses: $allowPartialAddresses\n      }\n    ) {\n      checkoutUserErrors {\n        code\n        field\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"], ["\n  mutation CheckoutCreate(\n    $email: String\n    $lineItems: [CheckoutLineItemInput!]\n    $shippingAddress: MailingAddressInput\n    $note: String\n    $customAttributes: [AttributeInput!]\n    $allowPartialAddresses: Boolean\n  ) {\n    checkoutCreate(\n      input: {\n        email: $email\n        lineItems: $lineItems\n        shippingAddress: $shippingAddress\n        note: $note\n        customAttributes: $customAttributes\n        allowPartialAddresses: $allowPartialAddresses\n      }\n    ) {\n      checkoutUserErrors {\n        code\n        field\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"])), checkoutFragment);
var templateObject_1$1;

var CHECKOUT_DISCOUNT_CODE_APPLY = gql(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  mutation CheckoutDiscountCodeApplyV2(\n    $checkoutId: ID!\n    $discountCode: String!\n  ) {\n    checkoutDiscountCodeApplyV2(\n      checkoutId: $checkoutId\n      discountCode: $discountCode\n    ) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"], ["\n  mutation CheckoutDiscountCodeApplyV2(\n    $checkoutId: ID!\n    $discountCode: String!\n  ) {\n    checkoutDiscountCodeApplyV2(\n      checkoutId: $checkoutId\n      discountCode: $discountCode\n    ) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"])), checkoutFragment);
var templateObject_1$2;

var CHECKOUT_DISCOUNT_CODE_REMOVE = gql(templateObject_1$3 || (templateObject_1$3 = __makeTemplateObject(["\n  mutation CheckoutDiscountCodeRemove($checkoutId: ID!) {\n    checkoutDiscountCodeRemove(checkoutId: $checkoutId) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n\n  ", "\n"], ["\n  mutation CheckoutDiscountCodeRemove($checkoutId: ID!) {\n    checkoutDiscountCodeRemove(checkoutId: $checkoutId) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n\n  ", "\n"])), checkoutFragment);
var templateObject_1$3;

var CHECKOUT_LINE_ITEMS_UPDATE = gql(templateObject_1$4 || (templateObject_1$4 = __makeTemplateObject(["\n  mutation CheckoutLineItemsUpdate(\n    $checkoutId: ID!\n    $lineItems: [CheckoutLineItemUpdateInput!]!\n  ) {\n    checkoutLineItemsUpdate(checkoutId: $checkoutId, lineItems: $lineItems) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"], ["\n  mutation CheckoutLineItemsUpdate(\n    $checkoutId: ID!\n    $lineItems: [CheckoutLineItemUpdateInput!]!\n  ) {\n    checkoutLineItemsUpdate(checkoutId: $checkoutId, lineItems: $lineItems) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"])), checkoutFragment);
var templateObject_1$4;

var CHECKOUT_LINE_ITEMS_ADD = gql(templateObject_1$5 || (templateObject_1$5 = __makeTemplateObject(["\n  mutation CheckoutLineItemsAdd(\n    $checkoutId: ID!\n    $lineItems: [CheckoutLineItemInput!]!\n  ) {\n    checkoutLineItemsAdd(checkoutId: $checkoutId, lineItems: $lineItems) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"], ["\n  mutation CheckoutLineItemsAdd(\n    $checkoutId: ID!\n    $lineItems: [CheckoutLineItemInput!]!\n  ) {\n    checkoutLineItemsAdd(checkoutId: $checkoutId, lineItems: $lineItems) {\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"])), checkoutFragment);
var templateObject_1$5;

var CHECKOUT_FETCH = gql(templateObject_1$6 || (templateObject_1$6 = __makeTemplateObject(["\n  query CheckoutQuery($id: ID!) {\n    node(id: $id) {\n      id\n      ... on Checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"], ["\n  query CheckoutQuery($id: ID!) {\n    node(id: $id) {\n      id\n      ... on Checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"])), checkoutFragment);
var templateObject_1$6;

var defaultQueries = {
    CHECKOUT_CREATE: CHECKOUT_CREATE,
    CHECKOUT_DISCOUNT_CODE_REMOVE: CHECKOUT_DISCOUNT_CODE_REMOVE,
    CHECKOUT_DISCOUNT_CODE_APPLY: CHECKOUT_DISCOUNT_CODE_APPLY,
    CHECKOUT_LINE_ITEMS_UPDATE: CHECKOUT_LINE_ITEMS_UPDATE,
    CHECKOUT_LINE_ITEMS_ADD: CHECKOUT_LINE_ITEMS_ADD,
    CHECKOUT_FETCH: CHECKOUT_FETCH,
};

var STARTED_REQUEST = 'STARTED_REQUEST';
var FETCHED_CHECKOUT = 'FETCHED_CHECKOUT';
var CREATED_CHECKOUT = 'CREATED_CHECKOUT';
var APPLIED_DISCOUNT = 'APPLIED_DISCOUNT';
var REMOVED_DISCOUNT = 'REMOVED_DISCOUNT';
var ADDED_LINE_ITEMS = 'ADDED_LINE_ITEMS';
var UPDATED_LINE_ITEMS = 'UPDATED_LINE_ITEMS';
var RECEIVED_ERRORS = 'RECEIVED_ERRORS';
var CART_CLEARED = 'RECEIVED_ERRORS';
var reducer = function (state, action) {
    switch (action.type) {
        case STARTED_REQUEST:
            return __assign(__assign({}, state), { loading: true });
        case CART_CLEARED:
            return __assign(__assign({}, state), { checkout: undefined, checkoutUserErrors: [], loading: false, ready: true });
        case FETCHED_CHECKOUT:
        case CREATED_CHECKOUT:
        case APPLIED_DISCOUNT:
        case REMOVED_DISCOUNT:
        case ADDED_LINE_ITEMS:
        case UPDATED_LINE_ITEMS:
        case RECEIVED_ERRORS:
            var checkoutUserErrors = action.checkoutUserErrors, checkout = action.checkout;
            return __assign(__assign({}, state), { checkoutUserErrors: checkoutUserErrors || [], checkout: checkout, loading: false, ready: true });
        default:
            return state;
    }
};

var VIEWER_CART_TOKEN = '_shopify_cart';
var setCookie = function (key, val, config) {
    if (val === undefined)
        return;
    var defaults = {
        expires: 7,
        path: '/',
    };
    var settings = __assign(__assign({}, defaults), config);
    var stringified = JSON.stringify(val);
    Cookies.set(key, stringified, settings);
};
var getCookie = function (key) {
    var value = Cookies.get(key);
    if (value)
        return JSON.parse(value);
    return null;
};
// export const removeData = (key: string, forceCookie: boolean): mixed => {};

var useReducer = useReducer$2, useEffect = useEffect$1;
/**
 * Setup
 */
var initialState = {
    ready: false,
    loading: true,
    checkoutUserErrors: [],
    checkout: undefined,
};
/**
 * Helper Functions
 */
var setViewerCartCookie = function (token) {
    return setCookie(VIEWER_CART_TOKEN, token);
};
var getViewerCartCookie = function () { return getCookie(VIEWER_CART_TOKEN); };
var useCheckout = function (_a) {
    var userQueries = _a.queries, query = _a.query;
    var _b = __assign(__assign({}, defaultQueries), userQueries), CHECKOUT_CREATE = _b.CHECKOUT_CREATE, CHECKOUT_FETCH = _b.CHECKOUT_FETCH, CHECKOUT_DISCOUNT_CODE_APPLY = _b.CHECKOUT_DISCOUNT_CODE_APPLY, CHECKOUT_DISCOUNT_CODE_REMOVE = _b.CHECKOUT_DISCOUNT_CODE_REMOVE, CHECKOUT_LINE_ITEMS_ADD = _b.CHECKOUT_LINE_ITEMS_ADD, CHECKOUT_LINE_ITEMS_UPDATE = _b.CHECKOUT_LINE_ITEMS_UPDATE;
    /**
     * State
     */
    var _c = useReducer(reducer, initialState), state = _c[0], dispatch = _c[1];
    /**
     * Base Methods
     *
     * These methods query the Shopify API. Their names should match the names of the
     * available queries & mutations.
     *
     */
    var checkoutCreate = function (variables) { return __awaiter(void 0, void 0, void 0, function () {
        var result, checkoutCreateResponse;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (state.checkout)
                        return [2 /*return*/, { checkout: state.checkout }];
                    return [4 /*yield*/, query(CHECKOUT_CREATE, variables || {})];
                case 1:
                    result = _a.sent();
                    checkoutCreateResponse = result.data.checkoutCreate;
                    if (checkoutCreateResponse.checkout)
                        setViewerCartCookie(checkoutCreateResponse.checkout.id);
                    dispatch(__assign({ type: CREATED_CHECKOUT }, checkoutCreateResponse));
                    return [2 /*return*/, checkoutCreateResponse];
            }
        });
    }); };
    var getOrCreateCheckout = function (variables) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, state.checkout
                    ? {
                        checkout: state.checkout,
                        checkoutUserErrors: state.checkoutUserErrors,
                    }
                    : checkoutCreate(variables)];
        });
    }); };
    var fetchCheckout = function () { return __awaiter(void 0, void 0, void 0, function () {
        var checkoutToken, variables, result, checkout;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    checkoutToken = getViewerCartCookie();
                    if (!checkoutToken) return [3 /*break*/, 2];
                    variables = { id: checkoutToken };
                    return [4 /*yield*/, query(CHECKOUT_FETCH, variables)];
                case 1:
                    result = _a.sent();
                    checkout = result.data ? result.data.node : undefined;
                    dispatch({ type: FETCHED_CHECKOUT, checkout: checkout });
                    return [3 /*break*/, 3];
                case 2:
                    /* When no token exists, dispatch this to set "loading" to false. */
                    /* This might deserve its own action type, "NOTHING_TO_FETCH" */
                    dispatch({ type: FETCHED_CHECKOUT, checkout: undefined });
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    }); };
    var checkoutLineItemsAdd = function (lineItems) { return __awaiter(void 0, void 0, void 0, function () {
        var checkout, variables, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getOrCreateCheckout()];
                case 1:
                    checkout = (_a.sent()).checkout;
                    if (!checkout)
                        throw new Error('checkoutLineItemsAdd was called before a checkout was created.');
                    dispatch({ type: STARTED_REQUEST });
                    variables = { lineItems: lineItems, checkoutId: checkout.id };
                    return [4 /*yield*/, query(CHECKOUT_LINE_ITEMS_ADD, variables)];
                case 2:
                    result = _a.sent();
                    dispatch(__assign({ type: ADDED_LINE_ITEMS }, result.data.checkoutLineItemsAdd));
                    return [2 /*return*/];
            }
        });
    }); };
    var checkoutLineItemsUpdate = function (lineItems) { return __awaiter(void 0, void 0, void 0, function () {
        var checkout, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getOrCreateCheckout()];
                case 1:
                    checkout = (_a.sent()).checkout;
                    if (!checkout)
                        throw new Error('There is no checkout to update');
                    dispatch({ type: STARTED_REQUEST });
                    return [4 /*yield*/, query(CHECKOUT_LINE_ITEMS_UPDATE, {
                            lineItems: lineItems,
                            checkoutId: checkout.id,
                        })];
                case 2:
                    result = _a.sent();
                    dispatch(__assign({ type: UPDATED_LINE_ITEMS }, result.data.checkoutLineItemsUpdate));
                    return [2 /*return*/];
            }
        });
    }); };
    var checkoutDiscountCodeApply = function (discountCode) { return __awaiter(void 0, void 0, void 0, function () {
        var checkout, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getOrCreateCheckout()];
                case 1:
                    checkout = (_a.sent()).checkout;
                    if (!checkout)
                        throw new Error('checkoutDiscountCodeApply was called before a checkout was created.');
                    dispatch({ type: STARTED_REQUEST });
                    return [4 /*yield*/, query(CHECKOUT_DISCOUNT_CODE_APPLY, {
                            checkoutId: checkout.id,
                            discountCode: discountCode,
                        })];
                case 2:
                    result = _a.sent();
                    dispatch(__assign({ type: APPLIED_DISCOUNT }, result.data.checkoutDiscountCodeApplyV2));
                    return [2 /*return*/];
            }
        });
    }); };
    var checkoutDiscountCodeRemove = function () { return __awaiter(void 0, void 0, void 0, function () {
        var checkout, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getOrCreateCheckout()];
                case 1:
                    checkout = (_a.sent()).checkout;
                    if (!checkout)
                        throw new Error('checkoutDiscountCodeRemove was called before a checkout was created.');
                    dispatch({ type: STARTED_REQUEST });
                    return [4 /*yield*/, query(CHECKOUT_DISCOUNT_CODE_REMOVE, {
                            checkoutId: checkout.id,
                        })];
                case 2:
                    result = _a.sent();
                    dispatch(__assign({ type: REMOVED_DISCOUNT }, result.data.checkoutDiscountCodeRemove));
                    return [2 /*return*/];
            }
        });
    }); };
    /**
     * Shortcut Methods
     *
     * These methods implement the base methods to provide simpler "shortcut"
     * functions with a simpler API
     */
    /* Adds a single line item to the checkout */
    var addLineItem = function (lineItem) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, checkoutLineItemsAdd([lineItem])
            /* Updates a single line item */
        ];
    }); }); };
    /* Updates a single line item */
    var updateLineItem = function (lineItem) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, checkoutLineItemsUpdate([lineItem])
            /* Clears the cart */
        ];
    }); }); };
    /* Clears the cart */
    var clearCheckout = function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/, dispatch({ type: CART_CLEARED })
            /**
             * Effects
             */
        ];
    }); }); };
    /**
     * Effects
     */
    useEffect(function () {
        fetchCheckout();
    }, []); // fetch the checkout on load
    var value = __assign(__assign({}, state), { 
        /* Base Methods */
        checkoutCreate: checkoutCreate,
        checkoutLineItemsAdd: checkoutLineItemsAdd,
        checkoutLineItemsUpdate: checkoutLineItemsUpdate,
        checkoutDiscountCodeApply: checkoutDiscountCodeApply,
        checkoutDiscountCodeRemove: checkoutDiscountCodeRemove,
        /* Shortcut Methods */
        addLineItem: addLineItem,
        updateLineItem: updateLineItem,
        clearCheckout: clearCheckout });
    return value;
};

var debounce = function (func, waitFor) {
    var timeout;
    var debounced = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        clearTimeout(timeout);
        timeout = setTimeout(function () { return func.apply(void 0, args); }, waitFor);
    };
    return debounced;
};
//
// function _debounce<T extends Function>(fn: T, delay) {
//   let timer = null
//   return function(...args: any) {
//     const context = this
//     clearTimeout(timer)
//     timer = setTimeout(function() {
//       fn.apply(context, args)
//     }, delay)
//   }
// }

// TODO: Break this into two queries
var SEARCH_QUERY = gql(templateObject_1$7 || (templateObject_1$7 = __makeTemplateObject(["\n  query SearchQuery(\n    $productFirst: Int!\n    $productAfter: String\n    $productLast: Int\n    $productBefore: String\n    $productReverse: Boolean\n    $productSortKey: ProductSortKeys\n    $productQuery: String!\n    $collectionFirst: Int!\n    $collectionAfter: String\n    $collectionLast: Int\n    $collectionBefore: String\n    $collectionReverse: Boolean\n    $collectionSortKey: CollectionSortKeys\n    $collectionQuery: String!\n  ) {\n    products(\n      first: $productFirst\n      after: $productAfter\n      last: $productLast\n      before: $productBefore\n      reverse: $productReverse\n      sortKey: $productSortKey\n      query: $productQuery\n    ) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...ProductFragment\n        }\n      }\n    }\n\n    collections(\n      first: $collectionFirst\n      after: $collectionAfter\n      last: $collectionLast\n      before: $collectionBefore\n      reverse: $collectionReverse\n      sortKey: $collectionSortKey\n      query: $collectionQuery\n    ) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...CollectionFragment\n        }\n      }\n    }\n  }\n  ", "\n  ", "\n"], ["\n  query SearchQuery(\n    $productFirst: Int!\n    $productAfter: String\n    $productLast: Int\n    $productBefore: String\n    $productReverse: Boolean\n    $productSortKey: ProductSortKeys\n    $productQuery: String!\n    $collectionFirst: Int!\n    $collectionAfter: String\n    $collectionLast: Int\n    $collectionBefore: String\n    $collectionReverse: Boolean\n    $collectionSortKey: CollectionSortKeys\n    $collectionQuery: String!\n  ) {\n    products(\n      first: $productFirst\n      after: $productAfter\n      last: $productLast\n      before: $productBefore\n      reverse: $productReverse\n      sortKey: $productSortKey\n      query: $productQuery\n    ) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...ProductFragment\n        }\n      }\n    }\n\n    collections(\n      first: $collectionFirst\n      after: $collectionAfter\n      last: $collectionLast\n      before: $collectionBefore\n      reverse: $collectionReverse\n      sortKey: $collectionSortKey\n      query: $collectionQuery\n    ) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          ...CollectionFragment\n        }\n      }\n    }\n  }\n  ", "\n  ", "\n"])), productFragment, collectionFragment);
var defaultQueries$1 = { SEARCH_QUERY: SEARCH_QUERY };
var templateObject_1$7;

var NEW_SEARCH = 'NEW_SEARCH';
var SET_SEARCH_TERM = 'SET_SEARCH_TERM';
var FETCH_MORE = 'FETCH_MORE';
var FETCHED_RESULTS = 'FETCHED_RESULTS';
var RESET = 'RESET';
var initialState$1 = {
    searchTerm: '',
    loading: false,
    results: [],
    products: [],
    collections: [],
    hasMoreResults: false,
    stale: false,
    lastSearchTerm: undefined,
};
var reducer$1 = function (state, action) {
    switch (action.type) {
        case NEW_SEARCH:
            return __assign(__assign({}, state), { searchTerm: action.searchTerm ? action.searchTerm : state.searchTerm, results: [], products: [], collections: [], lastSearchTerm: action.searchTerm
                    ? action.searchTerm
                    : state.searchTerm, loading: true });
        case SET_SEARCH_TERM:
            return __assign(__assign({}, state), { searchTerm: action.searchTerm, stale: action.searchTerm === state.lastSearchTerm });
        case FETCH_MORE:
            return __assign(__assign({}, state), { loading: true });
        case FETCHED_RESULTS:
            var results = action.results;
            var products = results.products ? unwindEdges(results.products)[0] : [];
            var collections = results.collections
                ? unwindEdges(results.collections)[0]
                : [];
            return __assign(__assign({}, state), { products: __spreadArrays(state.products, products), collections: __spreadArrays(state.collections, collections), results: __spreadArrays(state.results, [results]), loading: false });
        case RESET:
            // reset everything but the initial config
            return __assign(__assign({}, initialState$1), { config: state.config });
        default:
            return state;
    }
};

var useReducer$1 = useReducer$2, useMemo = useMemo$1;
/**
 * Utils
 */
var getSearchVariables = function (searchTerm, searchState) {
    var _a = searchState.config, pageSize = _a.pageSize, products = _a.products, collections = _a.collections;
    var productQuery = products ? "" + searchTerm : '__NO__SEARCH';
    var collectionQuery = collections ? "" + searchTerm : '__NO_SEARCH';
    return {
        productQuery: productQuery,
        productFirst: pageSize,
        // productAfter: productCursor,
        collectionQuery: collectionQuery,
        collectionFirst: pageSize,
    };
};
var memoizeQueryFunction = function (fn) { return memoizeJ(fn); };
var defaultConfig = {
    collections: true,
    products: true,
    memoize: true,
    debounce: 200,
    pageSize: 96,
};
var getInitialState = function (config) { return (__assign(__assign({}, initialState$1), { config: config })); };
/**
 * useSearch
 */
var useSearch = function (_a) {
    var userQueryFunction = _a.query, userConfig = _a.config, queries = _a.queries;
    var config = __assign(__assign({}, defaultConfig), userConfig);
    var _b = useReducer$1(reducer$1, getInitialState(config)), state = _b[0], dispatch = _b[1];
    /* Memoize the query function, and
     * debounce the Search function
     * Use React's useMemo so we only create these once */
    var query = state.config.memoize
        ? useMemo(function () { return memoizeQueryFunction(userQueryFunction); }, [
            userQueryFunction,
        ])
        : userQueryFunction;
    var SEARCH_QUERY = __assign(__assign({}, defaultQueries$1), queries).SEARCH_QUERY;
    var runSearchFn = function (variables) { return __awaiter(void 0, void 0, void 0, function () {
        var response, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, query(SEARCH_QUERY, variables)];
                case 1:
                    response = _a.sent();
                    data = response.data;
                    dispatch({ type: FETCHED_RESULTS, results: data });
                    return [2 /*return*/];
            }
        });
    }); };
    var runSearch = state.config.debounce && state.config.debounce > 0
        ? useMemo(function () { return debounce(runSearchFn, config.debounce); }, [config.debounce])
        : runSearchFn;
    /**
     * Updates the settings for a new search,
     * and resets product & collection cursors
     */
    var search = function (newSearchTerm) { return __awaiter(void 0, void 0, void 0, function () {
        var variables;
        return __generator(this, function (_a) {
            dispatch({ type: NEW_SEARCH, searchTerm: newSearchTerm });
            variables = getSearchVariables(newSearchTerm || state.searchTerm, state);
            runSearch(variables);
            return [2 /*return*/];
        });
    }); };
    var setSearchTerm = function (newSearchTerm) {
        if (newSearchTerm === void 0) { newSearchTerm = ''; }
        return dispatch({ type: SET_SEARCH_TERM, searchTerm: newSearchTerm });
    };
    var reset = function () { return dispatch({ type: RESET }); };
    // const loadMore = async () => {
    // 	if (!state.hasNextPage) return emptyResult
    // 	dispatch({ type: FETCH_MORE })
    // 	const variables = getSearchVariables(state.currentOptions, state)
    // 	const response = await query<SearchQueryResult, SearchQueryInputSearchInput>(SEARCH_QUERY, variables)
    // 	const { data } = response
    // 	dispatch({ type: FETCHED_RESULTS, results: data })
    // 	return data
    // }
    var searchTerm = state.searchTerm, loading = state.loading, products = state.products, collections = state.collections, results = state.results, hasMoreResults = state.hasMoreResults;
    return {
        /* State */
        searchTerm: searchTerm,
        loading: loading,
        results: results,
        hasMoreResults: hasMoreResults,
        products: products,
        collections: collections,
        /* Methods */
        search: search,
        setSearchTerm: setSearchTerm,
        reset: reset,
    };
};

var ShopifyContext = createContext(undefined);
var ShopifyConsumer = ShopifyContext.Consumer;
var useShopify = function () {
    var ctx = useContext(ShopifyContext);
    if (!ctx)
        throw new Error('`useShopify` must be used within a ShopifyProvider');
    return ctx;
};
var defaultConfig$1 = {
    search: undefined,
    checkout: undefined,
};
var ShopifyProvider = function (_a) {
    var children = _a.children, queries = _a.queries, query = _a.query, userConfig = _a.config;
    var config = __assign(__assign({}, defaultConfig$1), userConfig);
    var checkout = useCheckout({
        queries: queries,
        query: query,
        config: config.checkout ? config.checkout : undefined,
    });
    var search = useSearch({ queries: queries, query: query, config: config.search });
    var value = {
        checkout: checkout,
        search: search,
    };
    return (createElement(ShopifyContext.Provider, { value: value }, children));
};

/** The set of valid sort keys for the Article query. */
var ArticleSortKeys;
(function (ArticleSortKeys) {
    /** Sort by the `title` value. */
    ArticleSortKeys["Title"] = "TITLE";
    /** Sort by the `blog_title` value. */
    ArticleSortKeys["BlogTitle"] = "BLOG_TITLE";
    /** Sort by the `author` value. */
    ArticleSortKeys["Author"] = "AUTHOR";
    /** Sort by the `updated_at` value. */
    ArticleSortKeys["UpdatedAt"] = "UPDATED_AT";
    /** Sort by the `published_at` value. */
    ArticleSortKeys["PublishedAt"] = "PUBLISHED_AT";
    /** Sort by the `id` value. */
    ArticleSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    ArticleSortKeys["Relevance"] = "RELEVANCE";
})(ArticleSortKeys || (ArticleSortKeys = {}));
/** The set of valid sort keys for the Blog query. */
var BlogSortKeys;
(function (BlogSortKeys) {
    /** Sort by the `handle` value. */
    BlogSortKeys["Handle"] = "HANDLE";
    /** Sort by the `title` value. */
    BlogSortKeys["Title"] = "TITLE";
    /** Sort by the `id` value. */
    BlogSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    BlogSortKeys["Relevance"] = "RELEVANCE";
})(BlogSortKeys || (BlogSortKeys = {}));
/** Card brand, such as Visa or Mastercard, which can be used for payments. */
var CardBrand;
(function (CardBrand) {
    /** Visa */
    CardBrand["Visa"] = "VISA";
    /** Mastercard */
    CardBrand["Mastercard"] = "MASTERCARD";
    /** Discover */
    CardBrand["Discover"] = "DISCOVER";
    /** American Express */
    CardBrand["AmericanExpress"] = "AMERICAN_EXPRESS";
    /** Diners Club */
    CardBrand["DinersClub"] = "DINERS_CLUB";
    /** JCB */
    CardBrand["Jcb"] = "JCB";
})(CardBrand || (CardBrand = {}));
/** Possible error codes that could be returned by a checkout mutation. */
var CheckoutErrorCode;
(function (CheckoutErrorCode) {
    /** Input value is blank. */
    CheckoutErrorCode["Blank"] = "BLANK";
    /** Input value is invalid. */
    CheckoutErrorCode["Invalid"] = "INVALID";
    /** Input value is too long. */
    CheckoutErrorCode["TooLong"] = "TOO_LONG";
    /** Input value is not present. */
    CheckoutErrorCode["Present"] = "PRESENT";
    /** Input value should be less than maximum allowed value. */
    CheckoutErrorCode["LessThan"] = "LESS_THAN";
    /** Input value should be greater than or equal to minimum allowed value. */
    CheckoutErrorCode["GreaterThanOrEqualTo"] = "GREATER_THAN_OR_EQUAL_TO";
    /** Input value should be less or equal to maximum allowed value. */
    CheckoutErrorCode["LessThanOrEqualTo"] = "LESS_THAN_OR_EQUAL_TO";
    /** Checkout is already completed. */
    CheckoutErrorCode["AlreadyCompleted"] = "ALREADY_COMPLETED";
    /** Checkout is locked. */
    CheckoutErrorCode["Locked"] = "LOCKED";
    /** Input value is not supported. */
    CheckoutErrorCode["NotSupported"] = "NOT_SUPPORTED";
    /** Input email contains an invalid domain name. */
    CheckoutErrorCode["BadDomain"] = "BAD_DOMAIN";
    /** Input Zip is invalid for country provided. */
    CheckoutErrorCode["InvalidForCountry"] = "INVALID_FOR_COUNTRY";
    /** Input Zip is invalid for country and province provided. */
    CheckoutErrorCode["InvalidForCountryAndProvince"] = "INVALID_FOR_COUNTRY_AND_PROVINCE";
    /** Invalid state in country. */
    CheckoutErrorCode["InvalidStateInCountry"] = "INVALID_STATE_IN_COUNTRY";
    /** Invalid province in country. */
    CheckoutErrorCode["InvalidProvinceInCountry"] = "INVALID_PROVINCE_IN_COUNTRY";
    /** Invalid region in country. */
    CheckoutErrorCode["InvalidRegionInCountry"] = "INVALID_REGION_IN_COUNTRY";
    /** Shipping rate expired. */
    CheckoutErrorCode["ShippingRateExpired"] = "SHIPPING_RATE_EXPIRED";
    /** Gift card cannot be applied to a checkout that contains a gift card. */
    CheckoutErrorCode["GiftCardUnusable"] = "GIFT_CARD_UNUSABLE";
    /** Gift card is disabled. */
    CheckoutErrorCode["GiftCardDisabled"] = "GIFT_CARD_DISABLED";
    /** Gift card code is invalid. */
    CheckoutErrorCode["GiftCardCodeInvalid"] = "GIFT_CARD_CODE_INVALID";
    /** Gift card has already been applied. */
    CheckoutErrorCode["GiftCardAlreadyApplied"] = "GIFT_CARD_ALREADY_APPLIED";
    /** Gift card currency does not match checkout currency. */
    CheckoutErrorCode["GiftCardCurrencyMismatch"] = "GIFT_CARD_CURRENCY_MISMATCH";
    /** Gift card is expired. */
    CheckoutErrorCode["GiftCardExpired"] = "GIFT_CARD_EXPIRED";
    /** Gift card has no funds left. */
    CheckoutErrorCode["GiftCardDepleted"] = "GIFT_CARD_DEPLETED";
    /** Gift card was not found. */
    CheckoutErrorCode["GiftCardNotFound"] = "GIFT_CARD_NOT_FOUND";
    /** Cart does not meet discount requirements notice. */
    CheckoutErrorCode["CartDoesNotMeetDiscountRequirementsNotice"] = "CART_DOES_NOT_MEET_DISCOUNT_REQUIREMENTS_NOTICE";
    /** Discount expired. */
    CheckoutErrorCode["DiscountExpired"] = "DISCOUNT_EXPIRED";
    /** Discount disabled. */
    CheckoutErrorCode["DiscountDisabled"] = "DISCOUNT_DISABLED";
    /** Discount limit reached. */
    CheckoutErrorCode["DiscountLimitReached"] = "DISCOUNT_LIMIT_REACHED";
    /** Discount not found. */
    CheckoutErrorCode["DiscountNotFound"] = "DISCOUNT_NOT_FOUND";
    /** Customer already used once per customer discount notice. */
    CheckoutErrorCode["CustomerAlreadyUsedOncePerCustomerDiscountNotice"] = "CUSTOMER_ALREADY_USED_ONCE_PER_CUSTOMER_DISCOUNT_NOTICE";
    /** Checkout is already completed. */
    CheckoutErrorCode["Empty"] = "EMPTY";
    /** Not enough in stock. */
    CheckoutErrorCode["NotEnoughInStock"] = "NOT_ENOUGH_IN_STOCK";
    /** Missing payment input. */
    CheckoutErrorCode["MissingPaymentInput"] = "MISSING_PAYMENT_INPUT";
    /** The amount of the payment does not match the value to be paid. */
    CheckoutErrorCode["TotalPriceMismatch"] = "TOTAL_PRICE_MISMATCH";
    /** Line item was not found in checkout. */
    CheckoutErrorCode["LineItemNotFound"] = "LINE_ITEM_NOT_FOUND";
})(CheckoutErrorCode || (CheckoutErrorCode = {}));
/** The set of valid sort keys for the Collection query. */
var CollectionSortKeys;
(function (CollectionSortKeys) {
    /** Sort by the `title` value. */
    CollectionSortKeys["Title"] = "TITLE";
    /** Sort by the `updated_at` value. */
    CollectionSortKeys["UpdatedAt"] = "UPDATED_AT";
    /** Sort by the `id` value. */
    CollectionSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    CollectionSortKeys["Relevance"] = "RELEVANCE";
})(CollectionSortKeys || (CollectionSortKeys = {}));
/** ISO 3166-1 alpha-2 country codes with some differences. */
var CountryCode;
(function (CountryCode) {
    /** Afghanistan. */
    CountryCode["Af"] = "AF";
    /** Aland Islands. */
    CountryCode["Ax"] = "AX";
    /** Albania. */
    CountryCode["Al"] = "AL";
    /** Algeria. */
    CountryCode["Dz"] = "DZ";
    /** Andorra. */
    CountryCode["Ad"] = "AD";
    /** Angola. */
    CountryCode["Ao"] = "AO";
    /** Anguilla. */
    CountryCode["Ai"] = "AI";
    /** Antigua And Barbuda. */
    CountryCode["Ag"] = "AG";
    /** Argentina. */
    CountryCode["Ar"] = "AR";
    /** Armenia. */
    CountryCode["Am"] = "AM";
    /** Aruba. */
    CountryCode["Aw"] = "AW";
    /** Australia. */
    CountryCode["Au"] = "AU";
    /** Austria. */
    CountryCode["At"] = "AT";
    /** Azerbaijan. */
    CountryCode["Az"] = "AZ";
    /** Bahamas. */
    CountryCode["Bs"] = "BS";
    /** Bahrain. */
    CountryCode["Bh"] = "BH";
    /** Bangladesh. */
    CountryCode["Bd"] = "BD";
    /** Barbados. */
    CountryCode["Bb"] = "BB";
    /** Belarus. */
    CountryCode["By"] = "BY";
    /** Belgium. */
    CountryCode["Be"] = "BE";
    /** Belize. */
    CountryCode["Bz"] = "BZ";
    /** Benin. */
    CountryCode["Bj"] = "BJ";
    /** Bermuda. */
    CountryCode["Bm"] = "BM";
    /** Bhutan. */
    CountryCode["Bt"] = "BT";
    /** Bolivia. */
    CountryCode["Bo"] = "BO";
    /** Bosnia And Herzegovina. */
    CountryCode["Ba"] = "BA";
    /** Botswana. */
    CountryCode["Bw"] = "BW";
    /** Bouvet Island. */
    CountryCode["Bv"] = "BV";
    /** Brazil. */
    CountryCode["Br"] = "BR";
    /** British Indian Ocean Territory. */
    CountryCode["Io"] = "IO";
    /** Brunei. */
    CountryCode["Bn"] = "BN";
    /** Bulgaria. */
    CountryCode["Bg"] = "BG";
    /** Burkina Faso. */
    CountryCode["Bf"] = "BF";
    /** Burundi. */
    CountryCode["Bi"] = "BI";
    /** Cambodia. */
    CountryCode["Kh"] = "KH";
    /** Canada. */
    CountryCode["Ca"] = "CA";
    /** Cape Verde. */
    CountryCode["Cv"] = "CV";
    /** Caribbean Netherlands. */
    CountryCode["Bq"] = "BQ";
    /** Cayman Islands. */
    CountryCode["Ky"] = "KY";
    /** Central African Republic. */
    CountryCode["Cf"] = "CF";
    /** Chad. */
    CountryCode["Td"] = "TD";
    /** Chile. */
    CountryCode["Cl"] = "CL";
    /** China. */
    CountryCode["Cn"] = "CN";
    /** Christmas Island. */
    CountryCode["Cx"] = "CX";
    /** Cocos (Keeling) Islands. */
    CountryCode["Cc"] = "CC";
    /** Colombia. */
    CountryCode["Co"] = "CO";
    /** Comoros. */
    CountryCode["Km"] = "KM";
    /** Congo. */
    CountryCode["Cg"] = "CG";
    /** Congo, The Democratic Republic Of The. */
    CountryCode["Cd"] = "CD";
    /** Cook Islands. */
    CountryCode["Ck"] = "CK";
    /** Costa Rica. */
    CountryCode["Cr"] = "CR";
    /** Croatia. */
    CountryCode["Hr"] = "HR";
    /** Cuba. */
    CountryCode["Cu"] = "CU";
    /** Curaçao. */
    CountryCode["Cw"] = "CW";
    /** Cyprus. */
    CountryCode["Cy"] = "CY";
    /** Czech Republic. */
    CountryCode["Cz"] = "CZ";
    /** Côte d'Ivoire. */
    CountryCode["Ci"] = "CI";
    /** Denmark. */
    CountryCode["Dk"] = "DK";
    /** Djibouti. */
    CountryCode["Dj"] = "DJ";
    /** Dominica. */
    CountryCode["Dm"] = "DM";
    /** Dominican Republic. */
    CountryCode["Do"] = "DO";
    /** Ecuador. */
    CountryCode["Ec"] = "EC";
    /** Egypt. */
    CountryCode["Eg"] = "EG";
    /** El Salvador. */
    CountryCode["Sv"] = "SV";
    /** Equatorial Guinea. */
    CountryCode["Gq"] = "GQ";
    /** Eritrea. */
    CountryCode["Er"] = "ER";
    /** Estonia. */
    CountryCode["Ee"] = "EE";
    /** Eswatini. */
    CountryCode["Sz"] = "SZ";
    /** Ethiopia. */
    CountryCode["Et"] = "ET";
    /** Falkland Islands (Malvinas). */
    CountryCode["Fk"] = "FK";
    /** Faroe Islands. */
    CountryCode["Fo"] = "FO";
    /** Fiji. */
    CountryCode["Fj"] = "FJ";
    /** Finland. */
    CountryCode["Fi"] = "FI";
    /** France. */
    CountryCode["Fr"] = "FR";
    /** French Guiana. */
    CountryCode["Gf"] = "GF";
    /** French Polynesia. */
    CountryCode["Pf"] = "PF";
    /** French Southern Territories. */
    CountryCode["Tf"] = "TF";
    /** Gabon. */
    CountryCode["Ga"] = "GA";
    /** Gambia. */
    CountryCode["Gm"] = "GM";
    /** Georgia. */
    CountryCode["Ge"] = "GE";
    /** Germany. */
    CountryCode["De"] = "DE";
    /** Ghana. */
    CountryCode["Gh"] = "GH";
    /** Gibraltar. */
    CountryCode["Gi"] = "GI";
    /** Greece. */
    CountryCode["Gr"] = "GR";
    /** Greenland. */
    CountryCode["Gl"] = "GL";
    /** Grenada. */
    CountryCode["Gd"] = "GD";
    /** Guadeloupe. */
    CountryCode["Gp"] = "GP";
    /** Guatemala. */
    CountryCode["Gt"] = "GT";
    /** Guernsey. */
    CountryCode["Gg"] = "GG";
    /** Guinea. */
    CountryCode["Gn"] = "GN";
    /** Guinea Bissau. */
    CountryCode["Gw"] = "GW";
    /** Guyana. */
    CountryCode["Gy"] = "GY";
    /** Haiti. */
    CountryCode["Ht"] = "HT";
    /** Heard Island And Mcdonald Islands. */
    CountryCode["Hm"] = "HM";
    /** Holy See (Vatican City State). */
    CountryCode["Va"] = "VA";
    /** Honduras. */
    CountryCode["Hn"] = "HN";
    /** Hong Kong. */
    CountryCode["Hk"] = "HK";
    /** Hungary. */
    CountryCode["Hu"] = "HU";
    /** Iceland. */
    CountryCode["Is"] = "IS";
    /** India. */
    CountryCode["In"] = "IN";
    /** Indonesia. */
    CountryCode["Id"] = "ID";
    /** Iran, Islamic Republic Of. */
    CountryCode["Ir"] = "IR";
    /** Iraq. */
    CountryCode["Iq"] = "IQ";
    /** Ireland. */
    CountryCode["Ie"] = "IE";
    /** Isle Of Man. */
    CountryCode["Im"] = "IM";
    /** Israel. */
    CountryCode["Il"] = "IL";
    /** Italy. */
    CountryCode["It"] = "IT";
    /** Jamaica. */
    CountryCode["Jm"] = "JM";
    /** Japan. */
    CountryCode["Jp"] = "JP";
    /** Jersey. */
    CountryCode["Je"] = "JE";
    /** Jordan. */
    CountryCode["Jo"] = "JO";
    /** Kazakhstan. */
    CountryCode["Kz"] = "KZ";
    /** Kenya. */
    CountryCode["Ke"] = "KE";
    /** Kiribati. */
    CountryCode["Ki"] = "KI";
    /** Korea, Democratic People's Republic Of. */
    CountryCode["Kp"] = "KP";
    /** Kosovo. */
    CountryCode["Xk"] = "XK";
    /** Kuwait. */
    CountryCode["Kw"] = "KW";
    /** Kyrgyzstan. */
    CountryCode["Kg"] = "KG";
    /** Lao People's Democratic Republic. */
    CountryCode["La"] = "LA";
    /** Latvia. */
    CountryCode["Lv"] = "LV";
    /** Lebanon. */
    CountryCode["Lb"] = "LB";
    /** Lesotho. */
    CountryCode["Ls"] = "LS";
    /** Liberia. */
    CountryCode["Lr"] = "LR";
    /** Libyan Arab Jamahiriya. */
    CountryCode["Ly"] = "LY";
    /** Liechtenstein. */
    CountryCode["Li"] = "LI";
    /** Lithuania. */
    CountryCode["Lt"] = "LT";
    /** Luxembourg. */
    CountryCode["Lu"] = "LU";
    /** Macao. */
    CountryCode["Mo"] = "MO";
    /** Madagascar. */
    CountryCode["Mg"] = "MG";
    /** Malawi. */
    CountryCode["Mw"] = "MW";
    /** Malaysia. */
    CountryCode["My"] = "MY";
    /** Maldives. */
    CountryCode["Mv"] = "MV";
    /** Mali. */
    CountryCode["Ml"] = "ML";
    /** Malta. */
    CountryCode["Mt"] = "MT";
    /** Martinique. */
    CountryCode["Mq"] = "MQ";
    /** Mauritania. */
    CountryCode["Mr"] = "MR";
    /** Mauritius. */
    CountryCode["Mu"] = "MU";
    /** Mayotte. */
    CountryCode["Yt"] = "YT";
    /** Mexico. */
    CountryCode["Mx"] = "MX";
    /** Moldova, Republic of. */
    CountryCode["Md"] = "MD";
    /** Monaco. */
    CountryCode["Mc"] = "MC";
    /** Mongolia. */
    CountryCode["Mn"] = "MN";
    /** Montenegro. */
    CountryCode["Me"] = "ME";
    /** Montserrat. */
    CountryCode["Ms"] = "MS";
    /** Morocco. */
    CountryCode["Ma"] = "MA";
    /** Mozambique. */
    CountryCode["Mz"] = "MZ";
    /** Myanmar. */
    CountryCode["Mm"] = "MM";
    /** Namibia. */
    CountryCode["Na"] = "NA";
    /** Nauru. */
    CountryCode["Nr"] = "NR";
    /** Nepal. */
    CountryCode["Np"] = "NP";
    /** Netherlands. */
    CountryCode["Nl"] = "NL";
    /** Netherlands Antilles. */
    CountryCode["An"] = "AN";
    /** New Caledonia. */
    CountryCode["Nc"] = "NC";
    /** New Zealand. */
    CountryCode["Nz"] = "NZ";
    /** Nicaragua. */
    CountryCode["Ni"] = "NI";
    /** Niger. */
    CountryCode["Ne"] = "NE";
    /** Nigeria. */
    CountryCode["Ng"] = "NG";
    /** Niue. */
    CountryCode["Nu"] = "NU";
    /** Norfolk Island. */
    CountryCode["Nf"] = "NF";
    /** North Macedonia. */
    CountryCode["Mk"] = "MK";
    /** Norway. */
    CountryCode["No"] = "NO";
    /** Oman. */
    CountryCode["Om"] = "OM";
    /** Pakistan. */
    CountryCode["Pk"] = "PK";
    /** Palestinian Territory, Occupied. */
    CountryCode["Ps"] = "PS";
    /** Panama. */
    CountryCode["Pa"] = "PA";
    /** Papua New Guinea. */
    CountryCode["Pg"] = "PG";
    /** Paraguay. */
    CountryCode["Py"] = "PY";
    /** Peru. */
    CountryCode["Pe"] = "PE";
    /** Philippines. */
    CountryCode["Ph"] = "PH";
    /** Pitcairn. */
    CountryCode["Pn"] = "PN";
    /** Poland. */
    CountryCode["Pl"] = "PL";
    /** Portugal. */
    CountryCode["Pt"] = "PT";
    /** Qatar. */
    CountryCode["Qa"] = "QA";
    /** Republic of Cameroon. */
    CountryCode["Cm"] = "CM";
    /** Reunion. */
    CountryCode["Re"] = "RE";
    /** Romania. */
    CountryCode["Ro"] = "RO";
    /** Russia. */
    CountryCode["Ru"] = "RU";
    /** Rwanda. */
    CountryCode["Rw"] = "RW";
    /** Saint Barthélemy. */
    CountryCode["Bl"] = "BL";
    /** Saint Helena. */
    CountryCode["Sh"] = "SH";
    /** Saint Kitts And Nevis. */
    CountryCode["Kn"] = "KN";
    /** Saint Lucia. */
    CountryCode["Lc"] = "LC";
    /** Saint Martin. */
    CountryCode["Mf"] = "MF";
    /** Saint Pierre And Miquelon. */
    CountryCode["Pm"] = "PM";
    /** Samoa. */
    CountryCode["Ws"] = "WS";
    /** San Marino. */
    CountryCode["Sm"] = "SM";
    /** Sao Tome And Principe. */
    CountryCode["St"] = "ST";
    /** Saudi Arabia. */
    CountryCode["Sa"] = "SA";
    /** Senegal. */
    CountryCode["Sn"] = "SN";
    /** Serbia. */
    CountryCode["Rs"] = "RS";
    /** Seychelles. */
    CountryCode["Sc"] = "SC";
    /** Sierra Leone. */
    CountryCode["Sl"] = "SL";
    /** Singapore. */
    CountryCode["Sg"] = "SG";
    /** Sint Maarten. */
    CountryCode["Sx"] = "SX";
    /** Slovakia. */
    CountryCode["Sk"] = "SK";
    /** Slovenia. */
    CountryCode["Si"] = "SI";
    /** Solomon Islands. */
    CountryCode["Sb"] = "SB";
    /** Somalia. */
    CountryCode["So"] = "SO";
    /** South Africa. */
    CountryCode["Za"] = "ZA";
    /** South Georgia And The South Sandwich Islands. */
    CountryCode["Gs"] = "GS";
    /** South Korea. */
    CountryCode["Kr"] = "KR";
    /** South Sudan. */
    CountryCode["Ss"] = "SS";
    /** Spain. */
    CountryCode["Es"] = "ES";
    /** Sri Lanka. */
    CountryCode["Lk"] = "LK";
    /** St. Vincent. */
    CountryCode["Vc"] = "VC";
    /** Sudan. */
    CountryCode["Sd"] = "SD";
    /** Suriname. */
    CountryCode["Sr"] = "SR";
    /** Svalbard And Jan Mayen. */
    CountryCode["Sj"] = "SJ";
    /** Sweden. */
    CountryCode["Se"] = "SE";
    /** Switzerland. */
    CountryCode["Ch"] = "CH";
    /** Syria. */
    CountryCode["Sy"] = "SY";
    /** Taiwan. */
    CountryCode["Tw"] = "TW";
    /** Tajikistan. */
    CountryCode["Tj"] = "TJ";
    /** Tanzania, United Republic Of. */
    CountryCode["Tz"] = "TZ";
    /** Thailand. */
    CountryCode["Th"] = "TH";
    /** Timor Leste. */
    CountryCode["Tl"] = "TL";
    /** Togo. */
    CountryCode["Tg"] = "TG";
    /** Tokelau. */
    CountryCode["Tk"] = "TK";
    /** Tonga. */
    CountryCode["To"] = "TO";
    /** Trinidad and Tobago. */
    CountryCode["Tt"] = "TT";
    /** Tunisia. */
    CountryCode["Tn"] = "TN";
    /** Turkey. */
    CountryCode["Tr"] = "TR";
    /** Turkmenistan. */
    CountryCode["Tm"] = "TM";
    /** Turks and Caicos Islands. */
    CountryCode["Tc"] = "TC";
    /** Tuvalu. */
    CountryCode["Tv"] = "TV";
    /** Uganda. */
    CountryCode["Ug"] = "UG";
    /** Ukraine. */
    CountryCode["Ua"] = "UA";
    /** United Arab Emirates. */
    CountryCode["Ae"] = "AE";
    /** United Kingdom. */
    CountryCode["Gb"] = "GB";
    /** United States. */
    CountryCode["Us"] = "US";
    /** United States Minor Outlying Islands. */
    CountryCode["Um"] = "UM";
    /** Uruguay. */
    CountryCode["Uy"] = "UY";
    /** Uzbekistan. */
    CountryCode["Uz"] = "UZ";
    /** Vanuatu. */
    CountryCode["Vu"] = "VU";
    /** Venezuela. */
    CountryCode["Ve"] = "VE";
    /** Vietnam. */
    CountryCode["Vn"] = "VN";
    /** Virgin Islands, British. */
    CountryCode["Vg"] = "VG";
    /** Wallis And Futuna. */
    CountryCode["Wf"] = "WF";
    /** Western Sahara. */
    CountryCode["Eh"] = "EH";
    /** Yemen. */
    CountryCode["Ye"] = "YE";
    /** Zambia. */
    CountryCode["Zm"] = "ZM";
    /** Zimbabwe. */
    CountryCode["Zw"] = "ZW";
})(CountryCode || (CountryCode = {}));
/** The part of the image that should remain after cropping. */
var CropRegion;
(function (CropRegion) {
    /** Keep the center of the image. */
    CropRegion["Center"] = "CENTER";
    /** Keep the top of the image. */
    CropRegion["Top"] = "TOP";
    /** Keep the bottom of the image. */
    CropRegion["Bottom"] = "BOTTOM";
    /** Keep the left of the image. */
    CropRegion["Left"] = "LEFT";
    /** Keep the right of the image. */
    CropRegion["Right"] = "RIGHT";
})(CropRegion || (CropRegion = {}));
/** Currency codes. */
var CurrencyCode;
(function (CurrencyCode) {
    /** United States Dollars (USD). */
    CurrencyCode["Usd"] = "USD";
    /** Euro (EUR). */
    CurrencyCode["Eur"] = "EUR";
    /** United Kingdom Pounds (GBP). */
    CurrencyCode["Gbp"] = "GBP";
    /** Canadian Dollars (CAD). */
    CurrencyCode["Cad"] = "CAD";
    /** Afghan Afghani (AFN). */
    CurrencyCode["Afn"] = "AFN";
    /** Albanian Lek (ALL). */
    CurrencyCode["All"] = "ALL";
    /** Algerian Dinar (DZD). */
    CurrencyCode["Dzd"] = "DZD";
    /** Angolan Kwanza (AOA). */
    CurrencyCode["Aoa"] = "AOA";
    /** Argentine Pesos (ARS). */
    CurrencyCode["Ars"] = "ARS";
    /** Armenian Dram (AMD). */
    CurrencyCode["Amd"] = "AMD";
    /** Aruban Florin (AWG). */
    CurrencyCode["Awg"] = "AWG";
    /** Australian Dollars (AUD). */
    CurrencyCode["Aud"] = "AUD";
    /** Barbadian Dollar (BBD). */
    CurrencyCode["Bbd"] = "BBD";
    /** Azerbaijani Manat (AZN). */
    CurrencyCode["Azn"] = "AZN";
    /** Bangladesh Taka (BDT). */
    CurrencyCode["Bdt"] = "BDT";
    /** Bahamian Dollar (BSD). */
    CurrencyCode["Bsd"] = "BSD";
    /** Bahraini Dinar (BHD). */
    CurrencyCode["Bhd"] = "BHD";
    /** Burundian Franc (BIF). */
    CurrencyCode["Bif"] = "BIF";
    /** Belarusian Ruble (BYR). */
    CurrencyCode["Byr"] = "BYR";
    /** Belize Dollar (BZD). */
    CurrencyCode["Bzd"] = "BZD";
    /** Bermudian Dollar (BMD). */
    CurrencyCode["Bmd"] = "BMD";
    /** Bhutanese Ngultrum (BTN). */
    CurrencyCode["Btn"] = "BTN";
    /** Bosnia and Herzegovina Convertible Mark (BAM). */
    CurrencyCode["Bam"] = "BAM";
    /** Brazilian Real (BRL). */
    CurrencyCode["Brl"] = "BRL";
    /** Bolivian Boliviano (BOB). */
    CurrencyCode["Bob"] = "BOB";
    /** Botswana Pula (BWP). */
    CurrencyCode["Bwp"] = "BWP";
    /** Brunei Dollar (BND). */
    CurrencyCode["Bnd"] = "BND";
    /** Bulgarian Lev (BGN). */
    CurrencyCode["Bgn"] = "BGN";
    /** Burmese Kyat (MMK). */
    CurrencyCode["Mmk"] = "MMK";
    /** Cambodian Riel. */
    CurrencyCode["Khr"] = "KHR";
    /** Cape Verdean escudo (CVE). */
    CurrencyCode["Cve"] = "CVE";
    /** Cayman Dollars (KYD). */
    CurrencyCode["Kyd"] = "KYD";
    /** Central African CFA Franc (XAF). */
    CurrencyCode["Xaf"] = "XAF";
    /** Chilean Peso (CLP). */
    CurrencyCode["Clp"] = "CLP";
    /** Chinese Yuan Renminbi (CNY). */
    CurrencyCode["Cny"] = "CNY";
    /** Colombian Peso (COP). */
    CurrencyCode["Cop"] = "COP";
    /** Comorian Franc (KMF). */
    CurrencyCode["Kmf"] = "KMF";
    /** Congolese franc (CDF). */
    CurrencyCode["Cdf"] = "CDF";
    /** Costa Rican Colones (CRC). */
    CurrencyCode["Crc"] = "CRC";
    /** Croatian Kuna (HRK). */
    CurrencyCode["Hrk"] = "HRK";
    /** Czech Koruny (CZK). */
    CurrencyCode["Czk"] = "CZK";
    /** Danish Kroner (DKK). */
    CurrencyCode["Dkk"] = "DKK";
    /** Dominican Peso (DOP). */
    CurrencyCode["Dop"] = "DOP";
    /** East Caribbean Dollar (XCD). */
    CurrencyCode["Xcd"] = "XCD";
    /** Egyptian Pound (EGP). */
    CurrencyCode["Egp"] = "EGP";
    /** Ethiopian Birr (ETB). */
    CurrencyCode["Etb"] = "ETB";
    /** CFP Franc (XPF). */
    CurrencyCode["Xpf"] = "XPF";
    /** Fijian Dollars (FJD). */
    CurrencyCode["Fjd"] = "FJD";
    /** Gambian Dalasi (GMD). */
    CurrencyCode["Gmd"] = "GMD";
    /** Ghanaian Cedi (GHS). */
    CurrencyCode["Ghs"] = "GHS";
    /** Guatemalan Quetzal (GTQ). */
    CurrencyCode["Gtq"] = "GTQ";
    /** Guyanese Dollar (GYD). */
    CurrencyCode["Gyd"] = "GYD";
    /** Georgian Lari (GEL). */
    CurrencyCode["Gel"] = "GEL";
    /** Haitian Gourde (HTG). */
    CurrencyCode["Htg"] = "HTG";
    /** Honduran Lempira (HNL). */
    CurrencyCode["Hnl"] = "HNL";
    /** Hong Kong Dollars (HKD). */
    CurrencyCode["Hkd"] = "HKD";
    /** Hungarian Forint (HUF). */
    CurrencyCode["Huf"] = "HUF";
    /** Icelandic Kronur (ISK). */
    CurrencyCode["Isk"] = "ISK";
    /** Indian Rupees (INR). */
    CurrencyCode["Inr"] = "INR";
    /** Indonesian Rupiah (IDR). */
    CurrencyCode["Idr"] = "IDR";
    /** Israeli New Shekel (NIS). */
    CurrencyCode["Ils"] = "ILS";
    /** Iraqi Dinar (IQD). */
    CurrencyCode["Iqd"] = "IQD";
    /** Jamaican Dollars (JMD). */
    CurrencyCode["Jmd"] = "JMD";
    /** Japanese Yen (JPY). */
    CurrencyCode["Jpy"] = "JPY";
    /** Jersey Pound. */
    CurrencyCode["Jep"] = "JEP";
    /** Jordanian Dinar (JOD). */
    CurrencyCode["Jod"] = "JOD";
    /** Kazakhstani Tenge (KZT). */
    CurrencyCode["Kzt"] = "KZT";
    /** Kenyan Shilling (KES). */
    CurrencyCode["Kes"] = "KES";
    /** Kuwaiti Dinar (KWD). */
    CurrencyCode["Kwd"] = "KWD";
    /** Kyrgyzstani Som (KGS). */
    CurrencyCode["Kgs"] = "KGS";
    /** Laotian Kip (LAK). */
    CurrencyCode["Lak"] = "LAK";
    /** Latvian Lati (LVL). */
    CurrencyCode["Lvl"] = "LVL";
    /** Lebanese Pounds (LBP). */
    CurrencyCode["Lbp"] = "LBP";
    /** Lesotho Loti (LSL). */
    CurrencyCode["Lsl"] = "LSL";
    /** Liberian Dollar (LRD). */
    CurrencyCode["Lrd"] = "LRD";
    /** Lithuanian Litai (LTL). */
    CurrencyCode["Ltl"] = "LTL";
    /** Malagasy Ariary (MGA). */
    CurrencyCode["Mga"] = "MGA";
    /** Macedonia Denar (MKD). */
    CurrencyCode["Mkd"] = "MKD";
    /** Macanese Pataca (MOP). */
    CurrencyCode["Mop"] = "MOP";
    /** Malawian Kwacha (MWK). */
    CurrencyCode["Mwk"] = "MWK";
    /** Maldivian Rufiyaa (MVR). */
    CurrencyCode["Mvr"] = "MVR";
    /** Mexican Pesos (MXN). */
    CurrencyCode["Mxn"] = "MXN";
    /** Malaysian Ringgits (MYR). */
    CurrencyCode["Myr"] = "MYR";
    /** Mauritian Rupee (MUR). */
    CurrencyCode["Mur"] = "MUR";
    /** Moldovan Leu (MDL). */
    CurrencyCode["Mdl"] = "MDL";
    /** Moroccan Dirham. */
    CurrencyCode["Mad"] = "MAD";
    /** Mongolian Tugrik. */
    CurrencyCode["Mnt"] = "MNT";
    /** Mozambican Metical. */
    CurrencyCode["Mzn"] = "MZN";
    /** Namibian Dollar. */
    CurrencyCode["Nad"] = "NAD";
    /** Nepalese Rupee (NPR). */
    CurrencyCode["Npr"] = "NPR";
    /** Netherlands Antillean Guilder. */
    CurrencyCode["Ang"] = "ANG";
    /** New Zealand Dollars (NZD). */
    CurrencyCode["Nzd"] = "NZD";
    /** Nicaraguan Córdoba (NIO). */
    CurrencyCode["Nio"] = "NIO";
    /** Nigerian Naira (NGN). */
    CurrencyCode["Ngn"] = "NGN";
    /** Norwegian Kroner (NOK). */
    CurrencyCode["Nok"] = "NOK";
    /** Omani Rial (OMR). */
    CurrencyCode["Omr"] = "OMR";
    /** Panamian Balboa (PAB). */
    CurrencyCode["Pab"] = "PAB";
    /** Pakistani Rupee (PKR). */
    CurrencyCode["Pkr"] = "PKR";
    /** Papua New Guinean Kina (PGK). */
    CurrencyCode["Pgk"] = "PGK";
    /** Paraguayan Guarani (PYG). */
    CurrencyCode["Pyg"] = "PYG";
    /** Peruvian Nuevo Sol (PEN). */
    CurrencyCode["Pen"] = "PEN";
    /** Philippine Peso (PHP). */
    CurrencyCode["Php"] = "PHP";
    /** Polish Zlotych (PLN). */
    CurrencyCode["Pln"] = "PLN";
    /** Qatari Rial (QAR). */
    CurrencyCode["Qar"] = "QAR";
    /** Romanian Lei (RON). */
    CurrencyCode["Ron"] = "RON";
    /** Russian Rubles (RUB). */
    CurrencyCode["Rub"] = "RUB";
    /** Rwandan Franc (RWF). */
    CurrencyCode["Rwf"] = "RWF";
    /** Samoan Tala (WST). */
    CurrencyCode["Wst"] = "WST";
    /** Saudi Riyal (SAR). */
    CurrencyCode["Sar"] = "SAR";
    /** Sao Tome And Principe Dobra (STD). */
    CurrencyCode["Std"] = "STD";
    /** Serbian dinar (RSD). */
    CurrencyCode["Rsd"] = "RSD";
    /** Seychellois Rupee (SCR). */
    CurrencyCode["Scr"] = "SCR";
    /** Singapore Dollars (SGD). */
    CurrencyCode["Sgd"] = "SGD";
    /** Sudanese Pound (SDG). */
    CurrencyCode["Sdg"] = "SDG";
    /** Syrian Pound (SYP). */
    CurrencyCode["Syp"] = "SYP";
    /** South African Rand (ZAR). */
    CurrencyCode["Zar"] = "ZAR";
    /** South Korean Won (KRW). */
    CurrencyCode["Krw"] = "KRW";
    /** South Sudanese Pound (SSP). */
    CurrencyCode["Ssp"] = "SSP";
    /** Solomon Islands Dollar (SBD). */
    CurrencyCode["Sbd"] = "SBD";
    /** Sri Lankan Rupees (LKR). */
    CurrencyCode["Lkr"] = "LKR";
    /** Surinamese Dollar (SRD). */
    CurrencyCode["Srd"] = "SRD";
    /** Swazi Lilangeni (SZL). */
    CurrencyCode["Szl"] = "SZL";
    /** Swedish Kronor (SEK). */
    CurrencyCode["Sek"] = "SEK";
    /** Swiss Francs (CHF). */
    CurrencyCode["Chf"] = "CHF";
    /** Taiwan Dollars (TWD). */
    CurrencyCode["Twd"] = "TWD";
    /** Thai baht (THB). */
    CurrencyCode["Thb"] = "THB";
    /** Tanzanian Shilling (TZS). */
    CurrencyCode["Tzs"] = "TZS";
    /** Trinidad and Tobago Dollars (TTD). */
    CurrencyCode["Ttd"] = "TTD";
    /** Tunisian Dinar (TND). */
    CurrencyCode["Tnd"] = "TND";
    /** Turkish Lira (TRY). */
    CurrencyCode["Try"] = "TRY";
    /** Turkmenistani Manat (TMT). */
    CurrencyCode["Tmt"] = "TMT";
    /** Ugandan Shilling (UGX). */
    CurrencyCode["Ugx"] = "UGX";
    /** Ukrainian Hryvnia (UAH). */
    CurrencyCode["Uah"] = "UAH";
    /** United Arab Emirates Dirham (AED). */
    CurrencyCode["Aed"] = "AED";
    /** Uruguayan Pesos (UYU). */
    CurrencyCode["Uyu"] = "UYU";
    /** Uzbekistan som (UZS). */
    CurrencyCode["Uzs"] = "UZS";
    /** Vanuatu Vatu (VUV). */
    CurrencyCode["Vuv"] = "VUV";
    /** Venezuelan Bolivares (VEF). */
    CurrencyCode["Vef"] = "VEF";
    /** Vietnamese đồng (VND). */
    CurrencyCode["Vnd"] = "VND";
    /** West African CFA franc (XOF). */
    CurrencyCode["Xof"] = "XOF";
    /** Yemeni Rial (YER). */
    CurrencyCode["Yer"] = "YER";
    /** Zambian Kwacha (ZMW). */
    CurrencyCode["Zmw"] = "ZMW";
})(CurrencyCode || (CurrencyCode = {}));
/** Possible error codes that could be returned by a customer mutation. */
var CustomerErrorCode;
(function (CustomerErrorCode) {
    /** Input value is blank. */
    CustomerErrorCode["Blank"] = "BLANK";
    /** Input value is invalid. */
    CustomerErrorCode["Invalid"] = "INVALID";
    /** Input value is already taken. */
    CustomerErrorCode["Taken"] = "TAKEN";
    /** Input value is too long. */
    CustomerErrorCode["TooLong"] = "TOO_LONG";
    /** Input value is too short. */
    CustomerErrorCode["TooShort"] = "TOO_SHORT";
    /** Unidentified customer. */
    CustomerErrorCode["UnidentifiedCustomer"] = "UNIDENTIFIED_CUSTOMER";
    /** Customer is disabled. */
    CustomerErrorCode["CustomerDisabled"] = "CUSTOMER_DISABLED";
    /** Input password starts or ends with whitespace. */
    CustomerErrorCode["PasswordStartsOrEndsWithWhitespace"] = "PASSWORD_STARTS_OR_ENDS_WITH_WHITESPACE";
    /** Input contains HTML tags. */
    CustomerErrorCode["ContainsHtmlTags"] = "CONTAINS_HTML_TAGS";
    /** Input contains URL. */
    CustomerErrorCode["ContainsUrl"] = "CONTAINS_URL";
    /** Invalid activation token. */
    CustomerErrorCode["TokenInvalid"] = "TOKEN_INVALID";
    /** Customer already enabled. */
    CustomerErrorCode["AlreadyEnabled"] = "ALREADY_ENABLED";
    /** Address does not exist. */
    CustomerErrorCode["NotFound"] = "NOT_FOUND";
})(CustomerErrorCode || (CustomerErrorCode = {}));
/** Digital wallet, such as Apple Pay, which can be used for accelerated checkouts. */
var DigitalWallet;
(function (DigitalWallet) {
    /** Apple Pay. */
    DigitalWallet["ApplePay"] = "APPLE_PAY";
    /** Android Pay. */
    DigitalWallet["AndroidPay"] = "ANDROID_PAY";
    /** Google Pay. */
    DigitalWallet["GooglePay"] = "GOOGLE_PAY";
    /** Shopify Pay. */
    DigitalWallet["ShopifyPay"] = "SHOPIFY_PAY";
})(DigitalWallet || (DigitalWallet = {}));
/** The method by which the discount's value is allocated onto its entitled lines. */
var DiscountApplicationAllocationMethod;
(function (DiscountApplicationAllocationMethod) {
    /** The value is spread across all entitled lines. */
    DiscountApplicationAllocationMethod["Across"] = "ACROSS";
    /** The value is applied onto every entitled line. */
    DiscountApplicationAllocationMethod["Each"] = "EACH";
    /** The value is specifically applied onto a particular line. */
    DiscountApplicationAllocationMethod["One"] = "ONE";
})(DiscountApplicationAllocationMethod || (DiscountApplicationAllocationMethod = {}));
/**
 * Which lines on the order that the discount is allocated over, of the type
 * defined by the Discount Application's target_type.
 */
var DiscountApplicationTargetSelection;
(function (DiscountApplicationTargetSelection) {
    /** The discount is allocated onto all the lines. */
    DiscountApplicationTargetSelection["All"] = "ALL";
    /** The discount is allocated onto only the lines it is entitled for. */
    DiscountApplicationTargetSelection["Entitled"] = "ENTITLED";
    /** The discount is allocated onto explicitly chosen lines. */
    DiscountApplicationTargetSelection["Explicit"] = "EXPLICIT";
})(DiscountApplicationTargetSelection || (DiscountApplicationTargetSelection = {}));
/** The type of line (i.e. line item or shipping line) on an order that the discount is applicable towards. */
var DiscountApplicationTargetType;
(function (DiscountApplicationTargetType) {
    /** The discount applies onto line items. */
    DiscountApplicationTargetType["LineItem"] = "LINE_ITEM";
    /** The discount applies onto shipping lines. */
    DiscountApplicationTargetType["ShippingLine"] = "SHIPPING_LINE";
})(DiscountApplicationTargetType || (DiscountApplicationTargetType = {}));
/** List of supported image content types. */
var ImageContentType;
(function (ImageContentType) {
    /** A PNG image. */
    ImageContentType["Png"] = "PNG";
    /** A JPG image. */
    ImageContentType["Jpg"] = "JPG";
    /** A WEBP image. */
    ImageContentType["Webp"] = "WEBP";
})(ImageContentType || (ImageContentType = {}));
/** Metafield value types. */
var MetafieldValueType;
(function (MetafieldValueType) {
    /** A string metafield. */
    MetafieldValueType["String"] = "STRING";
    /** An integer metafield. */
    MetafieldValueType["Integer"] = "INTEGER";
    /** A json string metafield. */
    MetafieldValueType["JsonString"] = "JSON_STRING";
})(MetafieldValueType || (MetafieldValueType = {}));
/** The set of valid sort keys for the Order query. */
var OrderSortKeys;
(function (OrderSortKeys) {
    /** Sort by the `processed_at` value. */
    OrderSortKeys["ProcessedAt"] = "PROCESSED_AT";
    /** Sort by the `total_price` value. */
    OrderSortKeys["TotalPrice"] = "TOTAL_PRICE";
    /** Sort by the `id` value. */
    OrderSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    OrderSortKeys["Relevance"] = "RELEVANCE";
})(OrderSortKeys || (OrderSortKeys = {}));
/** The set of valid sort keys for the Page query. */
var PageSortKeys;
(function (PageSortKeys) {
    /** Sort by the `title` value. */
    PageSortKeys["Title"] = "TITLE";
    /** Sort by the `updated_at` value. */
    PageSortKeys["UpdatedAt"] = "UPDATED_AT";
    /** Sort by the `id` value. */
    PageSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    PageSortKeys["Relevance"] = "RELEVANCE";
})(PageSortKeys || (PageSortKeys = {}));
/** The set of valid sort keys for the ProductCollection query. */
var ProductCollectionSortKeys;
(function (ProductCollectionSortKeys) {
    /** Sort by the `title` value. */
    ProductCollectionSortKeys["Title"] = "TITLE";
    /** Sort by the `price` value. */
    ProductCollectionSortKeys["Price"] = "PRICE";
    /** Sort by the `best-selling` value. */
    ProductCollectionSortKeys["BestSelling"] = "BEST_SELLING";
    /** Sort by the `created` value. */
    ProductCollectionSortKeys["Created"] = "CREATED";
    /** Sort by the `id` value. */
    ProductCollectionSortKeys["Id"] = "ID";
    /** Sort by the `manual` value. */
    ProductCollectionSortKeys["Manual"] = "MANUAL";
    /** Sort by the `collection-default` value. */
    ProductCollectionSortKeys["CollectionDefault"] = "COLLECTION_DEFAULT";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    ProductCollectionSortKeys["Relevance"] = "RELEVANCE";
})(ProductCollectionSortKeys || (ProductCollectionSortKeys = {}));
/** The set of valid sort keys for the ProductImage query. */
var ProductImageSortKeys;
(function (ProductImageSortKeys) {
    /** Sort by the `created_at` value. */
    ProductImageSortKeys["CreatedAt"] = "CREATED_AT";
    /** Sort by the `position` value. */
    ProductImageSortKeys["Position"] = "POSITION";
    /** Sort by the `id` value. */
    ProductImageSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    ProductImageSortKeys["Relevance"] = "RELEVANCE";
})(ProductImageSortKeys || (ProductImageSortKeys = {}));
/** The set of valid sort keys for the Product query. */
var ProductSortKeys;
(function (ProductSortKeys) {
    /** Sort by the `title` value. */
    ProductSortKeys["Title"] = "TITLE";
    /** Sort by the `product_type` value. */
    ProductSortKeys["ProductType"] = "PRODUCT_TYPE";
    /** Sort by the `vendor` value. */
    ProductSortKeys["Vendor"] = "VENDOR";
    /** Sort by the `updated_at` value. */
    ProductSortKeys["UpdatedAt"] = "UPDATED_AT";
    /** Sort by the `created_at` value. */
    ProductSortKeys["CreatedAt"] = "CREATED_AT";
    /** Sort by the `best_selling` value. */
    ProductSortKeys["BestSelling"] = "BEST_SELLING";
    /** Sort by the `price` value. */
    ProductSortKeys["Price"] = "PRICE";
    /** Sort by the `id` value. */
    ProductSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    ProductSortKeys["Relevance"] = "RELEVANCE";
})(ProductSortKeys || (ProductSortKeys = {}));
/** The set of valid sort keys for the ProductVariant query. */
var ProductVariantSortKeys;
(function (ProductVariantSortKeys) {
    /** Sort by the `title` value. */
    ProductVariantSortKeys["Title"] = "TITLE";
    /** Sort by the `sku` value. */
    ProductVariantSortKeys["Sku"] = "SKU";
    /** Sort by the `position` value. */
    ProductVariantSortKeys["Position"] = "POSITION";
    /** Sort by the `id` value. */
    ProductVariantSortKeys["Id"] = "ID";
    /**
     * During a search (i.e. when the `query` parameter has been specified on the connection) this sorts the
     * results by relevance to the search term(s). When no search query is specified, this sort key is not
     * deterministic and should not be used.
     */
    ProductVariantSortKeys["Relevance"] = "RELEVANCE";
})(ProductVariantSortKeys || (ProductVariantSortKeys = {}));
var TransactionKind;
(function (TransactionKind) {
    TransactionKind["Sale"] = "SALE";
    TransactionKind["Capture"] = "CAPTURE";
    TransactionKind["Authorization"] = "AUTHORIZATION";
    TransactionKind["EmvAuthorization"] = "EMV_AUTHORIZATION";
    TransactionKind["Change"] = "CHANGE";
})(TransactionKind || (TransactionKind = {}));
var TransactionStatus;
(function (TransactionStatus) {
    TransactionStatus["Pending"] = "PENDING";
    TransactionStatus["Success"] = "SUCCESS";
    TransactionStatus["Failure"] = "FAILURE";
    TransactionStatus["Error"] = "ERROR";
})(TransactionStatus || (TransactionStatus = {}));
/** Units of measurement for weight. */
var WeightUnit;
(function (WeightUnit) {
    /** 1 kilogram equals 1000 grams. */
    WeightUnit["Kilograms"] = "KILOGRAMS";
    /** Metric system unit of mass. */
    WeightUnit["Grams"] = "GRAMS";
    /** 1 pound equals 16 ounces. */
    WeightUnit["Pounds"] = "POUNDS";
    /** Imperial system unit of mass. */
    WeightUnit["Ounces"] = "OUNCES";
})(WeightUnit || (WeightUnit = {}));

var useState = useState$1;
var useProductVariant = function (product, options) {
    if (options === void 0) { options = {}; }
    var initialVariant = options.initialVariant;
    var variants = unwindEdges(product.variants)[0];
    if (!variants.length)
        throw new Error('The supplied product has no variants');
    /**
     * Private Methods
     */
    var findVariant = function (variantId) {
        var variant = variants.find(function (v) { return v.id === variantId; });
        if (!variant)
            throw new Error("There is no variant with the id \"" + variantId + "\" on the product " + product.title);
        return variant;
    };
    var getInitialState = function () {
        if (!initialVariant || initialVariant === 'first')
            return variants[0];
        if (initialVariant === 'last')
            return variants[variants.length - 1];
        return findVariant(initialVariant);
    };
    var _a = useState(getInitialState()), currentVariant = _a[0], setCurrentVariant = _a[1];
    /**
     * Public Methods
     */
    var selectVariant = function (variantId) {
        var variant = findVariant(variantId);
        setCurrentVariant(variant);
    };
    return {
        currentVariant: currentVariant,
        selectVariant: selectVariant,
    };
};

var useCheckout$1 = function () {
    var ctx = useContext(ShopifyContext);
    if (!ctx)
        throw new Error("useCheckout was called outside of a provider. Be sure to include a ShopifyProvider higher up in your App's component tree.");
    return ctx.checkout;
};
var useSearch$1 = function () {
    var ctx = useContext(ShopifyContext);
    if (!ctx)
        throw new Error("useCheckout was called outside of a provider. Be sure to include a ShopifyProvider higher up in your App's component tree.");
    return ctx.search;
};

export { ArticleSortKeys, BlogSortKeys, CardBrand, CheckoutErrorCode, CollectionSortKeys, CountryCode, CropRegion, CurrencyCode, CustomerErrorCode, DigitalWallet, DiscountApplicationAllocationMethod, DiscountApplicationTargetSelection, DiscountApplicationTargetType, ImageContentType, MetafieldValueType, OrderSortKeys, PageSortKeys, ProductCollectionSortKeys, ProductImageSortKeys, ProductSortKeys, ProductVariantSortKeys, ShopifyConsumer, ShopifyContext, ShopifyProvider, TransactionKind, TransactionStatus, WeightUnit, useCheckout$1 as useCheckout, useProductVariant, useSearch$1 as useSearch, useShopify };
//# sourceMappingURL=index.es.js.map
